﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArrayTask
{
    internal class TaskSecond
    {
        /// <summary>
        /// Метод, который создает и выводит на экран массив из n случайных целых чисел в диапазоне от -100 до 100 (число n вводится с клавиатуры), 
        /// подсчитывает количество четных и нечетных чисел, а также выводит сообщение о том, положительный или отрицательный каждый конкретный элемент 
        /// массива следующим образом: число … - положительное (отрицательное) (если число равно 0, то написать о том, что оно не является ни положительным ни отрицательным). 
        /// </summary>
        public static void PositiveAndNegative()
        {
            Random random = new Random();
            int countEven = 0;
            int countNotEven = 0;
            Console.WriteLine("Введите размерность массива");
            int[] arrayNam = new int[int.Parse(Console.ReadLine())];
            for (int i = 0; i < arrayNam.Length; i++)
            {
                arrayNam[i] = random.Next(-100, 100);
                if (arrayNam[i] % 2 == 0) countEven++;
                else countNotEven++;
            }

            foreach (int number in arrayNam)
            {
                if (number > 0) Console.WriteLine($"{number} - положительное\n------------------------");
                else if (number < 0) Console.WriteLine($"{number} - отрицательное\n------------------------");
                else Console.WriteLine($"{number} - ни положительное ни отрицательное\n------------------------");
            }
            Console.WriteLine($"Количество четных чисел - {countEven}\nКоличество нечетных чисел - {countNotEven}");
        }
        /// <summary>
        /// Метод, который создает и выводит на экран двумерный массив случайных целых чисел в диапазоне от -10 до 10, 
        /// размерность которого вводится с клавиатуры, а затем создает новый массив, в котором строки и столбцы первого 
        /// созданного массива меняются местами (то есть необходимо реализовать алгоритм транспонирования матрицы).
        /// </summary>
        public static void Transposition() 
        {
            Random random = new Random();
            Console.WriteLine("Введите размерность двуммерного массива через пробел");
            string[] row = Console.ReadLine().Split(" ");
            int[,] arrayNam = new int[int.Parse(row[0]), int.Parse(row[1])];
            for (int i = 0; i < arrayNam.GetLength(0); i++) 
            {
                for (int j = 0; j < arrayNam.GetLength(1); j++)
                {
                    arrayNam[i, j] = random.Next(-10, 11);
                }
            }
            int[,] newTransportArray = new int[arrayNam.GetLength(1), arrayNam.GetLength(0)];
            for (int i = 0; i < arrayNam.GetLength(1); i++)
            {
                for(int j = 0; j < arrayNam.GetLength(0); j++)
                {
                    newTransportArray[i, j] = arrayNam[j, i];
                }
            }
            for (int i = 0; i < arrayNam.GetLength(0); i++)
            {
                for (int j = 0; j < arrayNam.GetLength(1); j++)
                {
                    Console.Write("{0,5:0}",arrayNam[i, j]);
                }
                Console.WriteLine();
            }
            Console.WriteLine("\n-----------------------------------------------------------|");

            for (int i = 0; i < newTransportArray.GetLength(0); i++)
            {
                for (int j = 0; j < newTransportArray.GetLength(1); j++)
                {
                    Console.Write("{0,5:0}", newTransportArray[i, j]);
                }
                Console.WriteLine();
            }
        }
        /// <summary>
        /// Метод, который создает одномерный массив (размерность вводится с клавиатуры), заполняет его произвольными символами в диапазоне 
        /// от ‘а’ до ‘я’, и, используя оператор цикла по массиву foreach, для каждого элемента массива выводит его номер (код символа) следующим 
        /// образом: «Элемент …, его номер … и он (номер - код символа) четный (нечетный)»
        /// </summary>
        public static void CharArray()
        {
            Random random = new Random();
            Console.WriteLine("Введите размерность массива");
            char[] arrayChar = new char[int.Parse(Console.ReadLine())];
            for (int i = 0;i < arrayChar.Length;i++) 
            {
                arrayChar[i] = (char)random.Next('а', 'я' + 1);
            }
            foreach (var symbol in arrayChar)
            {
                var evenOrNotEven = (int code) =>
                {
                    if (code % 2 == 0) return "четный";
                    else return "нечетный";
                };
                Console.WriteLine($"Элемент {symbol}, его номер {Convert.ToInt32(symbol)} и он {evenOrNotEven(Convert.ToInt32(symbol))}");
            }
        }
        /// <summary>
        /// Метод, который создает двумерный массив, в котором совпадают количество строк и столбцов, а все элементы находятся в пределах от -10 до 10, 
        /// выводит его на экран и вычисляет сумму положительных элементов, находящихся под главной диагональю.
        /// </summary>
        public static void CountSumMainDiagonal()
        {
            int countSum = 0;
            Random random = new Random();
            Console.WriteLine("Введите размерность массива");
            int lengthArray = int.Parse(Console.ReadLine());
            int[,] arrayNam = new int[lengthArray, lengthArray];
            for (int i = 0; i < arrayNam.GetLength(0); i++)
            {
                for (int j = 0; j < arrayNam.GetLength(1); j++)
                {
                    arrayNam[i, j] = random.Next(-10, 11);
                }
            }
            for (int i = 0; i < arrayNam.GetLength(0); i++)
            {
                for (int j = 0; j < arrayNam.GetLength(1); j++)
                {
                    Console.Write("{0,5:0}", arrayNam[i, j]);
                }
                Console.WriteLine();
            }
            for(int i = 0; i < arrayNam.GetLength(0); i++)
            {
                for(int j = 0; j < arrayNam.GetLength(1); j++)
                {
                    if (j > i) countSum += arrayNam[j, i];
                }
            }
            Console.WriteLine(countSum);
        }
    }
}
